#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <libaosd/aosd.h>
/* #include <libaosd/aosd-text.h> */

#include "const-c.inc"

MODULE = X11::Aosd		PACKAGE = X11::Aosd		

INCLUDE: const-xs.inc

#-- object (de)allocators

Aosd *
aosd_new()

void
aosd_destroy(Aosd *aosd)

#-- object inspectors

#-- void aosd_get_name(Aosd* aosd, XClassHint* result);
#-- void aosd_get_names(Aosd* aosd, char** res_name, char** res_class);

AosdTransparency
aosd_get_transparency(Aosd *aosd)

void
aosd_get_geometry(Aosd* aosd)
    INIT:
    int x,y,width,height;
    
    PPCODE:
    aosd_get_geometry(aosd, &x, &y, &width, &height);
    
    XPUSHs(sv_2mortal(newSVnv(x)));
    XPUSHs(sv_2mortal(newSVnv(y)));
    XPUSHs(sv_2mortal(newSVnv(width)));
    XPUSHs(sv_2mortal(newSVnv(height)));

void
aosd_get_screen_size(Aosd* aosd)
    INIT:
    int width,height;

    PPCODE:
    aosd_get_screen_size(aosd, &width, &height);
    
    XPUSHs(sv_2mortal(newSVnv(width)));
    XPUSHs(sv_2mortal(newSVnv(height)));

Bool
aosd_get_is_shown(Aosd* aosd)

#-- object configurators

#-- void aosd_set_name(Aosd* aosd, XClassHint* name);
#-- void aosd_set_names(Aosd* aosd, char* res_name, char* res_class);

void
aosd_set_transparency(Aosd* aosd, AosdTransparency mode)

void
aosd_set_geometry(Aosd* aosd, int x, int y, int width, int height);

void
aosd_set_position(Aosd* aosd, unsigned pos, int width, int height);

void
aosd_set_position_offset(Aosd* aosd, int x_offset, int y_offset)

#-- void aosd_set_position_with_offset(Aosd* aosd,
#--     AosdCoordinate abscissa, AosdCoordinate ordinate, int width, int height,
#--     int x_offset, int y_offset);
#-- void aosd_set_renderer(Aosd* aosd, AosdRenderer renderer, void* user_data);
#-- void aosd_set_mouse_event_cb(Aosd* aosd, AosdMouseEventCb cb, void* user_data);
#-- void aosd_set_hide_upon_mouse_event(Aosd* aosd, Bool enable);


#-- object manipulators
void
aosd_render(Aosd* aosd)

void
aosd_show(Aosd* aosd);

void
aosd_hide(Aosd* aosd);


#-- X main loop processing
void
aosd_loop_once(Aosd* aosd)

void
aosd_loop_for(Aosd* aosd, unsigned loop_ms)


